#include <iostream>
using namespace std;

#define maziau(a,b) (a < b)
#define lygu(a,b) (a == b)
#define NIL &tuscias

typedef enum {JUODAS,RAUDONAS} mazgo_spalva;

typedef struct mazgas{
    struct mazgas *left;         
    struct mazgas *right;        
    struct mazgas *parent;       
    mazgo_spalva color;            
    int data; } mazgas;
    
mazgas tuscias = { NIL,NIL,NIL,JUODAS};       

void laukti();
void ekranas();
mazgas *iterpti(int ,mazgas *);
mazgas *spalvinam(mazgas *,mazgas *);
mazgas *sukam_kairen(mazgas *,mazgas *);
mazgas *sukam_desinen(mazgas *,mazgas *);

void parodyti(mazgas *);
void atlaisvinti_atminti(mazgas *);
void pag_split(int ,mazgas *);
void split(mazgas *);

mazgas *naujas_medis_S1;
mazgas *naujas_medis_S2;

int main(){
    int insert_data;    
    char pasirinkimas;
    mazgas *pag_medis_S;
    pag_medis_S = NIL;
    mazgas *kitas_medis;
    kitas_medis = NIL;
    
    do{  
        ekranas();
        cout <<"Pasirinkite:\n1 iterpimas\n";
        cout <<"2 split - dalinti medi\n";
        cout <<"3 Pavaizduoti dabartini medi\n";
        cout <<"4 Darbo pabaiga\n";
        pasirinkimas = getchar();
        switch(pasirinkimas){
            case '1':cout<< "Iveskite norima skaiciu\n";
                     cin >> insert_data;
                     pag_medis_S = iterpti(insert_data,pag_medis_S);
                     break;
            case '2':split(pag_medis_S);
                     break;         
            case '3':parodyti(pag_medis_S);
                     laukti();
                     break;         
        }
    
    } while (pasirinkimas != '4');    
    atlaisvinti_atminti(pag_medis_S);    
    return 0;
}

void laukti(){
     getchar();
     getchar();
}

void ekranas(){
     for (int i=0 ;i<=50 ;i++)
        cout <<"\n";
}

mazgas *iterpti(int skaicius,mazgas *medis){
    mazgas *root,*naujas_mazgas,*lapas,*tevas;
   
    if(medis == NIL){
        root = new mazgas;
        root -> left = NIL;
        root -> right = NIL;
        root -> parent = NIL;
        root -> color = JUODAS;
        root -> data = skaicius;
        return root;
    }
    else{
        root = medis;
        lapas = medis;
        tevas = NIL;
        while (lapas != NIL){
            if (lygu(lapas -> data, skaicius)){
                 cout << "Toks skaicius jau medyje yra\n";
                 laukti();
                 return root;
                 
            }
            tevas = lapas;
            lapas = maziau(skaicius,lapas->data) ? lapas->left : lapas->right;
        }

        if ((naujas_mazgas = new mazgas)==0){
            cout << "Klaida skiriant atminti \n";
            laukti();
            exit(1);
        }
        
        naujas_mazgas -> left = NIL;
        naujas_mazgas -> right = NIL;
        naujas_mazgas -> parent = tevas;
        naujas_mazgas -> color = RAUDONAS;
        naujas_mazgas -> data = skaicius;

        if (maziau(skaicius,tevas -> data)){
            tevas -> left = naujas_mazgas;
        }
        else{
            tevas -> right = naujas_mazgas;
        } 
        root = spalvinam(naujas_mazgas,root);                 
        return root;
    }        
}


mazgas  *spalvinam(mazgas *x,mazgas *root){
    mazgas *y; 
    while (x -> parent -> color == RAUDONAS ){
        if (x -> parent == x ->parent -> parent -> left){
            y = x -> parent -> parent -> right;
            if (y -> color == RAUDONAS ){   
                x -> parent -> color = JUODAS;
                x -> parent -> parent ->color = RAUDONAS;
                y -> color = JUODAS;
                x = x -> parent -> parent;
                if (x -> parent == NIL)
                    break; 
            }
            else{   
                if (x == x -> parent -> right){
                     x = x -> parent;
                     root = sukam_kairen(x,root);
                }
                x -> parent -> color = JUODAS;
                x -> parent -> parent ->color = RAUDONAS; 
                             
                root = sukam_desinen(x -> parent -> parent,root);
            }             
        }
        else{
            mazgas *y = x ->parent -> parent -> left;
            if (y -> color == RAUDONAS ){
                x -> parent -> color = JUODAS;
                y -> color = JUODAS;
                x -> parent -> parent -> color = RAUDONAS;
                x = x -> parent -> parent;
                if (x -> parent == NIL)
                    break; 
                
            }
            else{
                if( x == x -> parent -> left){
                    x = x -> parent;
                    root = sukam_desinen(x,root);
                }
                x -> parent -> color = JUODAS;
                x -> parent -> parent -> color = RAUDONAS;
                root = sukam_kairen(x -> parent -> parent, root);
            }
        }
    }
root -> color = JUODAS;   
return root;       
}                        


mazgas *sukam_kairen(mazgas *x,mazgas *root){
    mazgas *y = x ->right;
    x -> right = y -> left;    
               
    if (y -> left != NIL) 
        y -> left -> parent = x;
         
    if (y != NIL)
        y -> parent = x ->parent;
        
    if (x == x -> parent -> left)
        x -> parent -> left = y;
    else
        x -> parent -> right = y;    
    
    y -> left = x;
    if (x != NIL)
       x -> parent = y; 
       
    if (y -> parent == NIL )
        root = y;
    return root;                                       
}

mazgas *sukam_desinen(mazgas *x,mazgas *root){

    mazgas *y = x -> left;
    x -> left = y -> right;
      
    if(y -> right != NIL )
        y -> right -> parent = x; 
    
    if( y != NIL )
        y -> parent = x -> parent;

    if( x == x -> parent -> left )
        x -> parent -> left = y;
    else
        x -> parent -> right = y;
               
    y -> right = x;
    if( x != NIL )
       x -> parent = y;
       
    if (y -> parent == NIL){
        root = y;
    }
   return root;             
}

void parodyti(mazgas *medis_spauzd){
    if (medis_spauzd != NIL){
        cout << "(";
        parodyti(medis_spauzd -> left);
        if (medis_spauzd -> color ==RAUDONAS){   
              if (medis_spauzd -> parent == NIL)
                  cout << medis_spauzd->data <<" *R - ";
              else
                  cout << medis_spauzd->data <<" R - ";
        }    
        if (medis_spauzd -> color == JUODAS){   
              if (medis_spauzd -> parent == NIL)
                  cout << medis_spauzd->data <<" *B - ";
              else
                  cout << medis_spauzd->data <<" B - ";
        }    
        parodyti(medis_spauzd -> right);
        cout << ")";
    }    
}          

void atlaisvinti_atminti(mazgas *root){
    if (root != NIL){
        atlaisvinti_atminti(root->left);
        atlaisvinti_atminti(root->right);
        delete[] root;
    }
}

void pag_split(int xyz_split,mazgas *medelis){                          
     if (medelis != NIL){
         pag_split(xyz_split,medelis -> left);
                          
         if (maziau(medelis -> data , xyz_split))  
             naujas_medis_S1 = iterpti(medelis -> data,naujas_medis_S1); 
         else
             naujas_medis_S2 = iterpti(medelis -> data,naujas_medis_S2);
              
         pag_split(xyz_split,medelis -> right);
     }             
}

void split(mazgas *medis){
     int split_elementas;
     naujas_medis_S1 = NIL;
     naujas_medis_S2 = NIL;
     if ( medis == NIL ){
         cout << "Medis yra tuscias\n";
         laukti();
     }
     else{   
         cout << "Prasome ivesti skaiciu\n";
         cin >> split_elementas;
         pag_split(split_elementas,medis);
         
         cout << "Pirmas medis\n";       
         parodyti(naujas_medis_S1);
         cout <<"\nAntras medis\n";
         parodyti(naujas_medis_S2);
         atlaisvinti_atminti(naujas_medis_S1);
         atlaisvinti_atminti(naujas_medis_S2); 
         laukti();           
     }
}
